
0668  116807    ld      de,#0768
066b  cd5e07    call    #075e
066e  f3        di      
066f  0192f7    ld      bc,#f792
0672  ed49      out     (c),c
0674  05        dec     b
0675  0e10      ld      c,#10
0677  ed49      out     (c),c
0679  08        ex      af,af'
067a  f5        push    af
067b  d9        exx     
067c  c5        push    bc
067d  0100f5    ld      bc,#f500
0680  d9        exx     

0681  dd218c07  ld      ix,#078c			;; load address


;; 93f3
;; one byte for sync marker
0685  11f093    ld      de,#93f0			;; length
0688  3eff      ld      a,#ff				;; sync byte marker
068a  37        scf     
068b  cda106    call    #06a1

068e  0182f7    ld      bc,#f782
0691  ed49      out     (c),c
0693  d9        exx     
0694  c1        pop     bc
0695  ed49      out     (c),c
0697  d9        exx     
0698  f1        pop     af
0699  08        ex      af,af'
069a  cd8c07    call    #078c				;; decrunch/decrypt
069d  fb        ei      
069e  c36496    jp      #9664				;; execute

;;--------------------------------------------------------------
;; load

06a1  14        inc     d
;; zero flag is clear
;; carry flag is set
06a2  08        ex      af,af'
06a3  15        dec     d
06a4  01107f    ld      bc,#7f10			;; select border
06a7  ed49      out     (c),c
06a9  0e4b      ld      c,#4b
06ab  ed49      out     (c),c
06ad  d9        exx     
06ae  ed78      in      a,(c)
06b0  d9        exx     
06b1  1f        rra     
06b2  e640      and     #40
06b4  f602      or      #02
06b6  4f        ld      c,a
06b7  bf        cp      a
06b8  c0        ret     nz

06b9  cd3707    call    #0737			; pulse
06bc  30fa      jr      nc,#06b8        ; (-6)

06be  211504    ld      hl,#0415
06c1  10fe      djnz    #06c1           ; (-2)
06c3  2b        dec     hl
06c4  7c        ld      a,h
06c5  b5        or      l
06c6  20f9      jr      nz,#06c1        ; (-7)

06c8  cd3307    call    #0733			; wave
06cb  30eb      jr      nc,#06b8        ; (-21)

;;----------------------------------------
;; look for at least 256 pulses of pilot
06cd  069c      ld      b,#9c
06cf  cd3307    call    #0733			; wave
06d2  30e4      jr      nc,#06b8        ; (-28)
06d4  3ec6      ld      a,#c6
06d6  b8        cp      b
06d7  30e0      jr      nc,#06b9        ; (-32)
06d9  24        inc     h
06da  20f1      jr      nz,#06cd        ; (-15)
;;----------------------------------------
;; keep fetching pilot pulses waiting for sync
06dc  06c9      ld      b,#c9
06de  cd3707    call    #0737			; pulse
06e1  30d5      jr      nc,#06b8        ; (-43)
06e3  78        ld      a,b
06e4  fed4      cp      #d4
06e6  30f4      jr      nc,#06dc        ; (-12)

;;---------------------------------------

06e8  cd3707    call    #0737			; pulse
06eb  d0        ret     nc

;;---------------------------------------
06ec  79        ld      a,c
06ed  ee03      xor     #03
06ef  4f        ld      c,a

06f0  2600      ld      h,#00			; initialise checksum

06f2  06cd      ld      b,#cd			; initialise timing constant
06f4  181f      jr      #0715           

;;----------------------------------------------------

06f6  08        ex      af,af'
;; C = pulse counter+previous state of cassette data input
;; A = sync byte
06f7  2007      jr      nz,#0700        ; check sync byte
06f9  300f      jr      nc,#070a        ; test checksum

;; get to here if zero flag is set
;; OR if carry flag is set

;; store byte
06fb  dd7500    ld      (ix+#00),l

;; - increment mem pointer
;; - decrement count 
;; - continue to load more bytes
06fe  180f      jr      #070f           

;;----------------------------------------------------
;; test sync byte
;;
;; A = sync byte
;; bit 7 of C is zero. 
;; Therefore this instruction will clear the carry.
0700  cb11      rl      c

0702  ad        xor     l		; byte loaded
0703  c0        ret     nz		; exit...

;; zero flag is now set

0704  79        ld      a,c
0705  1f        rra     
0706  4f        ld      c,a

0707  13        inc     de
0708  1807      jr      #0711           ; (7)

;;------------------------------------

070a  dd7e00    ld      a,(ix+#00)

;; loaded byte
070d  ad        xor     l
070e  c0        ret     nz

;;------------------------------------

070f  dd23      inc     ix				; increment mem pointer
0711  1b        dec     de				; decrement byte count

0712  08        ex      af,af'

;;-----------------------------------------------
;; read a byte
0713  06ce      ld      b,#ce
0715  2e01      ld      l,#01
0717  cd3307    call    #0733			; time wave
071a  d0        ret     nc				; if carry flag is clear, there has been an error

;; B = time between transitions
;; compare this against the expected timing
;; and use this to generate the bit value
071b  3edc      ld      a,#dc
071d  b8        cp      b
071e  cb15      rl      l
0720  06cd      ld      b,#cd
0722  30f3      jr      nc,#0717        ; (-13)
;; L = loaded byte

;;-----------------------------------------------------------
;; h = checksum value calculated so far
0724  7c        ld      a,h
0725  ad        xor     l
0726  67        ld      h,a

;;-----------------------------------------------------------
;; check if we have loaded all the data

0727  7a        ld      a,d
0728  b3        or      e
0729  20cb      jr      nz,#06f6        ; (-53)

;;-----------------------------------------------------------
;; to get here, all bytes must have been loaded successfully
;; and all checksum(s) must be valid.

;; set border to black
072b  01007f    ld      bc,#7f00
072e  3e54      ld      a,#54
0730  ed79      out     (c),a

0732  c9        ret     

;;-------------------------------------------------------
;; time wave

0733  cd3707    call    #0737			; pulse
0736  d0        ret     nc

;;-------------------------------------------------------
;; time pulse/edge

0737  3e18      ld      a,#18
0739  3d        dec     a
073a  20fd      jr      nz,#0739        ; (-3)

;; clear carry flag
073c  a7        and     a

;;-------------------------------------------------------
;; measure the time to the next edge transition
;; 
;; B will hold the count of number of tests
;; bit 6 of C holds previous cassette data input state
073d  04        inc     b
073e  c8        ret     z				; if B reaches 0 then quit. The pulse
										; is very long and therefore is invalid.

073f  d9        exx     
0740  ed78      in      a,(c)			; read cassette data input (bit 7)
0742  d9        exx     
0743  1f        rra						
0744  a9        xor     c				
										; if value of cassette data input has changed,
										; bit 6 will be "1". Otherwise bit 6 will be 0
0745  e640      and     #40				; isolate state of bit 6
0747  28f4      jr      z,#073d         ; if state has not changed, loop

;; cassette data input has changed state

0749  79        ld      a,c
074a  ee40      xor     #40		
074c  e65f      and     #5f		 
								; bit 6 holds state of cassette data input
								
								; bits 4-0 hold a counter which counts each edge.
								; The value is between 0 and 95 and wraps back to zero
								; after 95.
								; - this value/2 is the number of waves; where one wave
								; defines a single bit.
								; - this value/16 is the number of bytes; where one byte
								; is composed of 8 waves
								; - this counter is used to generate the border colour

074e  3c        inc     a		; increment count in bits 4-0
074f  4f        ld      c,a


0750  e63f      and     #3f		; index of hardware colour (0-63)
0752  f640      or      #40		; bit 7=0, bit 6=1, Gate Array function "Set colour for selected pen"
								; A = value to write direct to Gate Array to set colour for selected pen

0754  d9        exx     
;; A = hardware colour value + Gate Array function (bits 7 and 6)
;; set colour for border as this is the currently selected "pen"
0755  067f      ld      b,#7f	; Gate Array I/O port
0757  ed79      out     (c),a

;; since we changed B, reset it back for cassette read
0759  06f5      ld      b,#f5	; PPI port B I/O port

075b  d9        exx     
;; C = counter and previous state of cassette data input
;; B = count which describes the time between edge transitions
;; A = hardware colour value

075c  37        scf				; set carry flag to indicate edge was ok
075d  c9        ret     

;;-------------------------------------------------------

075e  1a        ld      a,(de)
075f  feff      cp      #ff
0761  c8        ret     z
0762  cd5abb    call    #bb5a
0765  13        inc     de
0766  18f6      jr      #075e           ; (-10)

;;-------------------------------------------------------

0768  1c        inc     e
0769  00        nop     
076a  00        nop     
076b  00        nop     
076c  1c        inc     e
076d  010f0f    ld      bc,#0f0f
0770  1d        dec     e
0771  00        nop     
0772  00        nop     
0773  04        inc     b
0774  011f0c    ld      bc,#0c1f
0777  0c        inc     c
0778  52        ld      d,d
0779  4f        ld      c,a
077a  43        ld      b,e
077b  4b        ld      c,e
077c  59        ld      e,c
077d  2063      jr      nz,#07e2        ; (99)
077f  61        ld      h,c
0780  72        ld      (hl),d
0781  67        ld      h,a
0782  61        ld      h,c
0783  6e        ld      l,(hl)
0784  64        ld      h,h
0785  6f        ld      l,a
0786  2e2e      ld      l,#2e
0788  2eff      ld      l,#ff
078a  00        nop     
